<?php
namespace PME\Controllers\Rotulacao;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

class AlunoController {
    protected $connection;

    public function __construct($connection) {
        $this->connection = $connection;
	}
	
	public function relateAluno(DTO\Request\Row $request, DTO\Response $response) {
		$rows = $request->getRow();
		$this->connection->beginTransaction();
		try {
		    foreach($rows as $row) {
		        if ($this->validateAluno($row)) {
		            $insert = "INSERT INTO RELACALUNO(CDFILIAL, CDSERVFILI, CDFILCENTPME, CDTIPOCARD, CDTIPOPRAT, CDRELACALUNO, CDALUNO) 
		                            VALUES(:CDFILIAL, :CDSERVFILI, :CDFILCENTPME, :CDTIPOCARD, :CDTIPOPRAT, :CDRELACALUNO, :CDALUNO)";
		            $params = array(
		                'CDFILIAL' => $row['CDFILIAL'],
                        'CDSERVFILI' => $row['CDSERVFILI'],
                        'CDFILCENTPME' => $row['CDFILCENTPME'],
                        'CDTIPOCARD' => $row['CDTIPOCARD'],
                        'CDTIPOPRAT' => $row['CDTIPOPRAT'],
                        'CDRELACALUNO' => $row['CDRELACALUNO'],
                        'CDALUNO' => $row['CDALUNO'],
		            );
		            $stmt = $this->connection->prepare($insert)->execute($params); 
		        } else {
		            $this->connection->rollBack();
					$response->addDataset(new DataSet('relateAluno', array('ERROR_ALUNO_RELACIONADO')));
					return;
		        }
		    }
		    $this->connection->commit();
			$response->addDataSet(new DataSet("relateAluno", array()));
		} catch (\Exception $e) {
		    $this->connection->rollBack();
	    	$response->setError(new Error($e->getMessage(), 500)); 
		}
	}
	
	private function validateAluno($row) {
	    $query = "SELECT COUNT(CDALUNO) AS COUNT FROM RELACALUNO WHERE CDFILIAL <> :CDFILIAL AND CDALUNO = :CDALUNO";
	    $params = array(
	        "CDFILIAL" => $row['CDFILIAL'],
	        "CDALUNO"  => $row['CDALUNO'],
	    );
	    $result = $this->connection->fetchAssoc($query, $params);
		return $result['COUNT'] == 0;
	}
}